//////////////////////////////////////////////////////////////////////////
// spieleprogrammierer.de-Programmier-Contest #10                       //
// ******************************************************************** //
// Titel: ...... "Zahlenbersetzer"                                     //
// Typ: ........ Krze des Codes                                        //
// Deadline: ... 23.11.2008                                             //
// Abgabe: ..... contest@spieleprogrammierer.de                         //
// ******************************************************************** //
//                                                                      //
// Aufgabenstellung und Regeln siehe:                                   //
// http://www.spieleprogrammierer.de/phpBB2/viewtopic.php?t=10412       //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include <iostream>
#include <string>
#include <cstdlib>

//////////////////////////////////////////////////////////////////////////

const unsigned int MIN_NUMBER = 1;
const unsigned int MAX_NUMBER = 3999;

//////////////////////////////////////////////////////////////////////////

// "my_nickname" bitte durch deinen Nickname ersetzen, z.B. "hans_wurst".
// Zum Einreichen der Lsung einfach den kompletten Namespace schicken!
namespace my_nickname
{
    // >>> DEINE FUNKTION - BITTE IMPLEMENTIEREN! <<<
    void translate_number(const char* p_roman_in,
                          char* p_text_out)
    {
        // BEGIN COUNT

        // Hier werden die Token gezhlt!

		// END COUNT
    }
}

//////////////////////////////////////////////////////////////////////////

namespace reference
{
    // Referenzimplementierung
    // (Sie darf die Standardbibliothek benutzen, haha!)
    void translate_number(const char* p_roman_in,
                          char* p_text_out)
    {
        // zuerst die rmische Zahl in eine Dezimalzahl umwandeln
        int n = 0;
        int current = 0;
        while(true)
        {
            // Ende des Strings erreicht?
            if(!*p_roman_in) break;

            // letzten Zifferwert merken
            int previous = current;

            // nchsten Zifferwert holen
            switch(*p_roman_in++)
            {
                case 'I': current = 1; break;
                case 'V': current = 5; break;
                case 'X': current = 10; break;
                case 'L': current = 50; break;
                case 'C': current = 100; break;
                case 'D': current = 500; break;
                case 'M': current = 1000; break;
            }

            // aufaddieren
            n += current;

            // Wenn die vorhergehende Ziffer kleiner als die Aktuelle war,
            // dann liegt ein Fall wie "IX" vor. Statt 11 ist das 9,
            // also muss das Doppelte der kleineren Ziffer abgezogen werden.
            if(previous < current) n -= 2 * previous;
        }

        // Zahlennamen
        std::string numbers[] = { "", "ein", "zwei", "drei", "vier", "fuenf", "sechs", "sieben", "acht", "neun", "zehn", "elf", "zwoelf", "dreizehn", "vierzehn", "fuenfzehn", "sechzehn", "siebzehn", "achtzehn", "neunzehn" };
		std::string tens[] = { "", "", "zwanzig", "dreissig", "vierzig", "fuenfzig", "sechzig", "siebzig", "achtzig", "neunzig" };

        // Nun den Zahlennamen generieren.
        // Zuerst die Tausender und Hunderter.
        std::string result;
        if(n >= 1000) { result += numbers[n / 1000] + "tausend"; n %= 1000; }
        if(n >= 100) { result += numbers[n / 100] + "hundert"; n %= 100; }

        if(n <= 19)
        {
            // Zahlen bis 19 sind zu unregelmig und werden direkt aus dem Array genommen.
            result += numbers[n];

            // "eins" statt "ein"
            if(n == 1) result += 's';
        }
        else
        {
            // Ab 20 wird es regelmiger.
            // Erst die Einer, gefolgt von einem "und":
            if(n % 10) result += numbers[n % 10] + "und";

            // dann die Zehner
			result += tens[n / 10];
        }

        // Ergebnis kopieren
        strcpy(p_text_out, result.c_str());
    }
}

//////////////////////////////////////////////////////////////////////////

// Funktionszeigertyp
typedef void (* TranslateFunctionPointer)(const char*, char*);

//////////////////////////////////////////////////////////////////////////

int main()
{
    // Tests
    const char* p_tests[] = {
        "I", "eins",
        "II", "zwei",
        "III", "drei",
        "IV", "vier",
        "IX", "neun",
        "XIX", "neunzehn",
        "XXIV", "vierundzwanzig",
        "XXXIX", "neununddreissig",
        "XL", "vierzig",
        "L", "fuenfzig",
        "LX", "sechzig",
        "LXX", "siebzig",
        "XCIX", "neunundneunzig",
        "DLXXXIX", "fuenfhundertneunundachtzig",
        "CMXCIX", "neunhundertneunundneunzig",
        "M", "eintausend",
        "MI", "eintausendeins",
        "MCMLXXXIV", "eintausendneunhundertvierundachtzig",
        "MMMCMXCIX", "dreitausendneunhundertneunundneunzig",
        0 };

    // Tests durchfhren
    const char** pp_input = p_tests;
    const char** pp_correct_answer = p_tests + 1;
    int num_errors = 0;
    while(*pp_input)
    {
        // Ausgabe-String vorbereiten
        char answer[256];
        for(unsigned int i = 0; i < 256; ++i) answer[i] = static_cast<char>(rand() % 256);

        // Zahl konvertieren
        my_nickname::translate_number(*pp_input, answer);

        // Korrektheit testen
        if(std::string(answer) != *pp_correct_answer)
        {
            // Fehler!
            std::cout << "Fehler!" << std::endl;
            std::cout << "Eingabe: " << *pp_input << std::endl;
            std::cout << "Ausgabe: " << answer << std::endl;
            std::cout << "Korrekt: " << *pp_correct_answer << std::endl << std::endl;
            ++num_errors;
        }

        // weiter zum nchsten Test
        pp_input += 2;
        pp_correct_answer += 2;
    }

    std::cout << num_errors << " Fehler insgesamt" << std::endl;

    return 0;
}
